#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Inspire by Conbagui's video tutorial found here: https://www.deviantart.com/conbagui/art/Christmas-Stocking-Gimp-2-10-Video-tutorial-776422496

# author: Pocholo
# date: 9/27/21

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 


from gimpfu import *
import gettext
import os, sys,time 

gettext.install("gimp20", gimp.locale_directory, unicode=True)

def pm_christmas_personalized_stocking(customtext, fontname):
           
    #Initiates the temporary state
    pdb.gimp_context_set_defaults()
	#Create the woooden background
    img = pdb.gimp_image_new(1200, 1400, RGB)
    backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_context_set_foreground((230, 230, 230))
    pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
    
    #Image process
    pdb.gimp_display_new(img)
    
    #Create the stocking
    soxLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Stocking bottom", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, soxLayer, 0)
    pdb.gimp_drawable_fill(soxLayer, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((128, 0, 0))
    pdb.gimp_image_select_polygon(img, CHANNEL_OP_REPLACE, 166, [330,390,700,250,730,360,740,420,760,540,770,610,775,640,780,660,785,676,800,700,860,770,875,794,880,805,
	886,820,887,826,888,833,888,840,887,844,887,850,884,860,880,873,870,893,862,904,854,914,837,930,817,943,754,983,735,997,715,1015,696,1035,634,1110,627,1116,623,1120,600,1132,
    590,1136,575,1142,555,1147,536,1150,530,1150,524,1150,520,1150,514,1150,500,1145,490,1142,463,1132,450,1125,443,1120,433,1110,430,1105,424,1096,422,1090,421,1084,420,1077,
    419,1070,418,1055,418,1041,420,1032,426,1014,426,1011,432,997,442,980,480,931,486,921,495,908,498,900,504,886,510,871,512,860,514,850,516,837,516,820,516,800,513,776,507,747,
	501,731,497,722,475,677,444,620,392,525,353,450,342,432,337,410,330,390])
    pdb.gimp_edit_bucket_fill(soxLayer,  
                        BUCKET_FILL_FG,  #fill_mode
                     LAYER_MODE_NORMAL,  #paint_mode
                                   100,  #opacity
                                   255,  #threshold
                                 FALSE,  #sample_merged
                                     0,  #x
                                     0)  #y
	
    pdb.gimp_image_select_item(img, 2, soxLayer)
    pdb.plug_in_sel2path(img, soxLayer) 
    pdb.gimp_selection_none(img)
    
    #Fuzz around the stocking
    stockFuzz = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Stocking Fuzz", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, stockFuzz, 0)
    pdb.gimp_drawable_fill(stockFuzz, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground((128, 0, 0))
    pdb.gimp_brushes_set_brush("Fur")
    pdb.gimp_context_set_brush_size(30)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.25)
    pdb.gimp_context_set_brush_force(0.5)
    pdb.gimp_context_set_paint_method("gimp-paintbrush")
    pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
    vectors1 = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
    pdb.gimp_context_set_dynamics("Random Angle")
    pdb.gimp_drawable_edit_stroke_item(stockFuzz, vectors1)
    pdb.gimp_context_set_dynamics("Dynamics Off")
    
    #Texture in the stocking 
    textureLayer1 = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Stocking texture", 45, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, textureLayer1, 0)
    pdb.gimp_drawable_fill(textureLayer1, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, soxLayer)
    pdb.gimp_edit_bucket_fill(textureLayer1,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
    
    pdb.plug_in_hsv_noise(img, textureLayer1, 8, 2, 4, 255)
    pdb.plug_in_wind(img, textureLayer1, 12, 3, 10, 0, 2)
    
    
    textureLayer2 = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Stocking texture copy", 20, LAYER_MODE_SOFTLIGHT)
    pdb.gimp_image_add_layer(img, textureLayer2, 0)
    pdb.gimp_drawable_fill(textureLayer2, FILL_TRANSPARENT)
    pdb.gimp_edit_bucket_fill(textureLayer2,  
                             BUCKET_FILL_FG,  #fill_mode
                          LAYER_MODE_NORMAL,  #paint_mode
                                        100,  #opacity
                                        255,  #threshold
                                      FALSE,  #sample_merged
                                          0,  #x
                                          0)  #y
    
    pdb.plug_in_solid_noise(img, textureLayer2, FALSE, FALSE, 0, 15, 4, 4)
    textureLayer1 = pdb.gimp_image_merge_down(img, textureLayer2, CLIP_TO_IMAGE)
    
    #Sox shadow
    soxShadow = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Shadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, soxShadow, 3)
    pdb.gimp_drawable_fill(soxShadow, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_edit_bucket_fill(soxShadow,  
                         BUCKET_FILL_FG,  #fill_mode
                      LAYER_MODE_NORMAL,  #paint_mode
                                    100,  #opacity
                                    255,  #threshold
                                  FALSE,  #sample_merged
                                      0,  #x
                                      0)  #y
   
    pdb.gimp_selection_none(img)
    pdb.plug_in_gauss(img, soxShadow, 12, 12, 1)   #method=1
    
	#Top fuzz
    fuzzLayer1 = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Top fuzz", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, fuzzLayer1, 0)
    pdb.gimp_drawable_fill(fuzzLayer1, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("White")
    pdb.gimp_image_select_round_rectangle(img, CHANNEL_OP_REPLACE, 310, 256, 424, 208, 25, 25)
    pdb.gimp_edit_bucket_fill(fuzzLayer1,  
                          BUCKET_FILL_FG,  #fill_mode
                       LAYER_MODE_NORMAL,  #paint_mode
                                     100,  #opacity
                                     255,  #threshold
                                   FALSE,  #sample_merged
                                       0,  #x
                                       0)  #y
    fuzzLayer1 = pdb.gimp_item_transform_rotate(fuzzLayer1, -0.35, TRUE, 530, 360)
    floating_sel = pdb.gimp_image_get_floating_sel(img)
    pdb.gimp_floating_sel_anchor(floating_sel)
    fuzzLayer1 = pdb.gimp_image_get_layer_by_name(img, "Top fuzz")
    pdb.gimp_image_select_item(img, 2, fuzzLayer1)
    pdb.plug_in_sel2path(img, fuzzLayer1) 
    pdb.gimp_selection_none(img)
    
    #Fuzz around the top
    topFuzz = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Fuzz", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, topFuzz, 0)
    pdb.gimp_drawable_fill(topFuzz, FILL_TRANSPARENT)
    pdb.gimp_brushes_set_brush("Fur")
    pdb.gimp_context_set_brush_size(100)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_brush_aspect_ratio(0)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(0.25)
    pdb.gimp_context_set_brush_force(0.5)
    pdb.gimp_context_set_paint_method("gimp-paintbrush")
    pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
    vectors2 = pdb.gimp_image_get_vectors_by_name(img, (_("Selection")+' #1'))
    pdb.gimp_context_set_dynamics("Random Angle")
    pdb.gimp_drawable_edit_stroke_item(topFuzz, vectors2)
    pdb.gimp_context_set_dynamics("Dynamics Off")
    fuzzLayer1 = pdb.gimp_image_merge_down(img, topFuzz, CLIP_TO_IMAGE)
    
    #Top fuzz texture 
    non_empty = pdb.gimp_edit_copy(fuzzLayer1)
    fuzzTexture = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Top fuzz texture", 75, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, fuzzTexture, 0)
    pdb.gimp_drawable_fill(fuzzTexture, FILL_TRANSPARENT)
    fuzzTexture = pdb.gimp_edit_paste(fuzzTexture, FALSE)
    pdb.gimp_floating_sel_anchor(fuzzTexture) 
    fuzzTexture = pdb.gimp_image_get_layer_by_name(img, "Top fuzz texture")
    pdb.gimp_image_select_item(img, 2, fuzzLayer1)
    pdb.plug_in_hsv_noise(img, fuzzTexture, 8, 2, 4, 255)
    pdb.plug_in_wind(img, fuzzTexture, 12, 3, 10, 0, 2)
    pdb.plug_in_gauss(img, fuzzTexture, 5, 5, 1)   #method=1
    fuzzLayer1 = pdb.gimp_image_merge_down(img, fuzzTexture, CLIP_TO_IMAGE)
    
    #Top fuzz shadow
    TfuzzShadow = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Top fuzz shadow", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, TfuzzShadow, 1)
    pdb.gimp_drawable_fill(TfuzzShadow, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_edit_bucket_fill(TfuzzShadow,  
                           BUCKET_FILL_FG,  #fill_mode
                        LAYER_MODE_NORMAL,  #paint_mode
                                      100,  #opacity
                                      255,  #threshold
                                    FALSE,  #sample_merged
                                        0,  #x
                                        0)  #y
   
    pdb.gimp_selection_none(img)
    pdb.plug_in_gauss(img, TfuzzShadow, 12, 12, 1)   #method=1
    
    #New visible layer
    pdb.gimp_item_set_visible(backLayer, FALSE)
    pdb.gimp_item_set_visible(TfuzzShadow, FALSE)
    visible = pdb.gimp_layer_new_from_visible(img, img, "Visible")
    pdb.gimp_image_add_layer(img, visible, 0)
    pdb.gimp_image_select_item(img, 2, visible)
    
    #Inner shadow
    innShadow = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Inner shadow", 50, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, innShadow, 0)
    pdb.gimp_drawable_fill(innShadow, FILL_TRANSPARENT)
    pdb.gimp_context_set_foreground("Black")
    pdb.gimp_edit_bucket_fill(innShadow,  
                          BUCKET_FILL_FG,  #fill_mode
                       LAYER_MODE_NORMAL,  #paint_mode
                                     100,  #opacity
                                     255,  #threshold
                                   FALSE,  #sample_merged
                                       0,  #x
                                       0)  #y
    
    pdb.gimp_selection_shrink(img, 30)
    pdb.gimp_edit_clear(innShadow)
    pdb.gimp_image_select_item(img, 2, visible)
    pdb.plug_in_gauss(img, innShadow, 200, 200, 1)   #method=1
    pdb.gimp_selection_none(img)
    pdb.gimp_item_set_visible(backLayer, TRUE)
    pdb.gimp_item_set_visible(TfuzzShadow, TRUE)
	
    #Create the text		
    size = 200
    textW = size/1
    textH = size/0.4
    pdb.gimp_context_set_foreground("White")
    textLayer = pdb.gimp_text_layer_new(img, customtext, fontname, size, PIXELS)
    pdb.gimp_image_add_layer(img, textLayer, 0)
    pdb.gimp_layer_add_alpha(textLayer)
    pdb.gimp_text_layer_set_justification(textLayer, 2)
    pdb.gimp_text_layer_set_letter_spacing(textLayer, -25)
    pdb.gimp_text_layer_set_base_direction(textLayer, TEXT_DIRECTION_TTB_LTR_UPRIGHT)
    
    #Resize text
    pdb.gimp_layer_scale (textLayer, textW, textH, TRUE)
    
    #Making the text centered	
    textLayer = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer)
    wh = pdb.gimp_drawable_width(textLayer)
    hh = pdb.gimp_drawable_height(textLayer)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer)
    centerx=w/2
    centery=h/2
    adw=wh/2
    adh=hh/2
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer)
    pdb.gimp_layer_set_mode(textLayer, LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_opacity(textLayer, 100)  
    #Rename the text layer
    pdb.gimp_item_set_name(textLayer, "Text")
    
    #Center the text on the stocking
    textLayer = pdb.gimp_item_transform_translate(textLayer, 60, 40)
    textLayer = pdb.gimp_item_transform_rotate(textLayer, -0.35, TRUE, 530, 360)
    pdb.gimp_layer_resize_to_image_size(textLayer)
    	
    #Make active the bottom layer and done
    pdb.gimp_image_set_active_layer(img, backLayer)
    #Set the defaults
    pdb.gimp_context_set_defaults()
       
register(
    "pm_christmas_personalized_stocking",
    "Creates a Christmas stocking",
    "Creates a Christmas stocking with name",
    "Pocholo",
    "Pocholo",
    "2021",
    "Christmas Personalized Stocking",
    "",
    [
    (PF_STRING, "customtext", "Text sring", "GIMP"),
    (PF_FONT, "fontname", "Font name", "Kingthings Christmas 2,"),
    ],
    [],
    pm_christmas_personalized_stocking, menu="<Image>/Pocholo-scripts/Christmas Personalized Stocking",
    domain=("gimp20", gimp.locale_directory))
main()			